<template>
  <article class="view view--forum-section">
    <SectionDetail :codeName="codeName" @loaded="onLoaded" />
    <TopicList :route="sectionRoute" :offset="offset" :limit="limit" :section="codeName" />
  </article>
</template>

<script>
import { ref, computed, watch } from 'vue'
import { useRoute } from 'vue-router'
import { useStore } from 'vuex'
import { Constants, ValidationHelper } from '../../../core'
import SectionDetail from '../../components/section-detail.vue'
import TopicList from '../../components/topic-list.vue'

export default {
  name: 'ForumSectionView',
  components: {
    SectionDetail,
    TopicList,
  },
  setup() {
    const store = useStore()
    const route = useRoute()

    const section = ref(undefined)

    const codeName = computed(() => {
      return ValidationHelper.getString(route.params.codeName, '')
    })

    const offset = computed(() => {
      return ValidationHelper.getInteger(route.query.offset, 0)
    })

    const limit = computed(() => {
      return ValidationHelper.getInteger(route.query.limit, Constants.pagination.defaultPageLimit)
    })

    const sectionRoute = computed(() => {
      return codeName.value ? { name: 'forum-section', params: { codeName: codeName.value } } : null
    })

    const iconClass = computed(() => {
      return route.meta.iconClass
    })

    const title = computed(() => {
      return section.value?.displayName || codeName.value
    })

    const breadcrumbs = computed(() => {
      return [
        {
          text: 'Forum',
          route: { name: 'forum-forum' },
        },
        {
          text: title.value,
          route: null, // No link to self
        },
      ]
    })

    const onLoaded = (section) => {
      section.value = section
    }

    watch(title, (val) => {
      store.dispatch('core/setTitle', val)
    })

    watch(breadcrumbs, (val) => {
      store.dispatch('core/setBreadcrumbs', val)
    })

    store.dispatch('core/setIconClass', iconClass.value)

    return {
      sectionRoute,
      codeName,
      offset,
      limit,
      onLoaded,
    }
  },
}
</script>
